TopicMessageStore (ActiveMQ 1.1 API)
Keywords: org.codehaus.activemq.store.TopicMessageStore interface

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.codehaus.activemq.store
Interface TopicMessageStore

All Superinterfaces:
  MessageStore, Service

All Known Implementing Classes:
  BDbTopicMessageStore, BDbTopicMessageStore, CacheTopicMessageStore, JDBCTopicMessageStore, JdbmTopicMessageStore, VMTopicMessageStore

public interface TopicMessageStore
extends MessageStore

A MessageStore for durable topic subscriptions

Version:
  $Revision: 1.2 $

Method Summary
`void` | `decrementMessageCountAndMaybeDelete(MessageIdentity messageIdentity, MessageAck ack)` Decrement the reference count of this message ID and if there are no more references then delete the message from persistent store (or maybe archive it off somewhere)
`MessageIdentity` | `getLastestMessageIdentity()` Returns the last message identity that was delivered on this container which can then be used as a checkpoint so that when new durable consumers start, we know where to checkpoint their subscriptions.
`SubscriberEntry` | `getSubscriberEntry(ConsumerInfo info)` Finds the subscriber entry for the given consumer info
`void` | `incrementMessageCount(MessageIdentity messageId)` Increments the reference count of the message ID as its been dispatched to another subscriber.
`void` | `recoverSubscription(Subscription subscription, MessageIdentity lastDispatchedMessage)` For the new subcription find the last acknowledged message ID and then find any new messages since then and dispatch them to the subscription.
`void` | `setLastAcknowledgedMessageIdentity(Subscription subscription, MessageIdentity messageIdentity)` Stores the last acknowledged messgeID for the given subscription so that we can recover and commence dispatching messages from the last checkpoint
`void` | `setMessageContainer(MessageContainer container)` Called before the service is started so that the store can communicate with the container when recovering
`void` | `setSubscriberEntry(ConsumerInfo info, SubscriberEntry subscriberEntry)` Inserts or updates the subscriber info due to a subscription change

Methods inherited from interface org.codehaus.activemq.store.MessageStore
`addMessage, getMessage, recover, removeMessage`

Methods inherited from interface org.codehaus.activemq.service.Service
`start, stop`

Method Detail

### setMessageContainer

    public void setMessageContainer(MessageContainer container)

  Called before the service is started so that the store can communicate with the container when recovering

  Parameters:
    `container` -

### incrementMessageCount

    public void incrementMessageCount(MessageIdentity messageId)
                               throws JMSException

  Increments the reference count of the message ID as its been dispatched to another subscriber.

  Parameters:
    `messageId` -
  Throws:
    `JMSException`

### decrementMessageCountAndMaybeDelete

    public void decrementMessageCountAndMaybeDelete(MessageIdentity messageIdentity,
                                                    MessageAck ack)
                                             throws JMSException

  Decrement the reference count of this message ID and if there are no more references then delete the message from persistent store (or maybe archive it off somewhere)

  Parameters:
    `messageIdentity` -
    `ack` -
  Throws:
    `JMSException`

### setLastAcknowledgedMessageIdentity

    public void setLastAcknowledgedMessageIdentity(Subscription subscription,
                                                   MessageIdentity messageIdentity)
                                            throws JMSException

  Stores the last acknowledged messgeID for the given subscription so that we can recover and commence dispatching messages from the last checkpoint

  Parameters:
    `subscription` -
    `messageIdentity` -
  Throws:
    `JMSException`

### recoverSubscription

    public void recoverSubscription(Subscription subscription,
                                    MessageIdentity lastDispatchedMessage)
                             throws JMSException

  For the new subcription find the last acknowledged message ID and then find any new messages since then and dispatch them to the subscription.

  If this is a new subscription then the lastDispatchMessage should be written to the acknowledgement table to write a checkpoint so that when we recover we will start from the correct point.

  e.g. if we dispatched some messages to a new durable topic subscriber, then went down before acknowledging any messages, we need to know the correct point from which to recover from.

  Parameters:
    `subscription` -
    `lastDispatchedMessage` -
  Throws:
    `JMSException`

### getLastestMessageIdentity

    public MessageIdentity getLastestMessageIdentity()
                                              throws JMSException

  Returns the last message identity that was delivered on this container which can then be used as a checkpoint so that when new durable consumers start, we know where to checkpoint their subscriptions.

  Note that this method does not need to return a valid messageID, purely the sequence number.

  Returns:
    the last message identity which was persisted in the durable store or null if the store is empty.
  Throws:
    `JMSException`

### getSubscriberEntry

    public SubscriberEntry getSubscriberEntry(ConsumerInfo info)
                                       throws JMSException

  Finds the subscriber entry for the given consumer info

  Parameters:
    `info` -
  Returns:
  Throws:
    `JMSException`

### setSubscriberEntry

    public void setSubscriberEntry(ConsumerInfo info,
                                   SubscriberEntry subscriberEntry)
                            throws JMSException

  Inserts or updates the subscriber info due to a subscription change

  Parameters:
    `info` -
    `subscriberEntry` -
  Throws:
    `JMSException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 Protique, Ltd.. All Rights Reserved.